<?php

function post_install(){

    require_once 'modules/Administration/QuickRepairAndRebuild.php';

    echo "Performing first quick repair & rebuild ... <br>\n";
    $GLOBALS['log']->info('SugarAide Install: Performing first quick repair & rebuild');

    $autoexecute = false;
    $show_output = false;
    $randc = new RepairAndClear();
    $randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);

    echo "Performing second quick repair & rebuild ... <br>\n";
    $GLOBALS['log']->info('SugarAide Install: Performing second quick repair & rebuild');

    $autoexecute = false;
    $show_output = false;
    $randc = new RepairAndClear();
    $randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);


    $job = BeanFactory::getBean('Schedulers');
    $query = new SugarQuery();
    $query->from($job);
    $query->where()->in('job', array('function::SendUserNews', 'function::CleanUpGCMMessages'));
    $query->select(array('id', 'name'));
    foreach($query->execute() as $data) {
        $schedulerId = $data['id'];

        if (!empty($schedulerId)) {
            $job->mark_deleted($schedulerId);
            echo "\nRemoving \"{$data['name']}\" Scheduler ... <br>\n";
            $GLOBALS['log']->info('SugarAide Uninstall: Removing \"{$data[\'name\']}\" Scheduler.');
        }
    }

    echo "\nCreating \"Sending GCM Messages\" Scheduler.<br />\n";
    $GLOBALS['log']->info('SugarAide Install: Creating "Sending GCM Messages" Scheduler');

    $job = BeanFactory::getBean('Schedulers');
    $query = new SugarQuery();
    $query->from($job);
    $query->where()->equals('job', 'function::SendUserNews');
    $query->select(array('id'));
    $schedulerId = $query->getOne();
    if(empty($schedulerId)){
        global $timedate;
        $job->name = 'Sending GCM Messages';
        $job->job = 'function::SendUserNews';
        $job->date_time_start = $timedate->nowDb();
        $job->job_interval = '*/5::*::*::*::*';
        $job->status = 'Active';
        $job->catch_up = 1;
        $job->save();
    }

    echo "\nCreating \"Deleting History GCM Messages\" Scheduler.<br />\n";
    $GLOBALS['log']->info('SugarAide Install: Creating "Deleting History GCM Messages" Scheduler');

    $job = BeanFactory::getBean('Schedulers');
    $query = new SugarQuery();
    $query->from($job);
    $query->where()->equals('job', 'function::CleanUpGCMMessages');
    $query->select(array('id'));
    $schedulerId = $query->getOne();
    if(empty($schedulerId)){
        global $timedate;
        $job->name = 'Deleting History GCM Messages';
        $job->job = 'function::CleanUpGCMMessages';
        $job->date_time_start = $timedate->nowDb();
        $job->job_interval = '*::3::*::*::*';
        $job->status = 'Active';
        $job->catch_up = 1;
        $job->save();
    }

    echo "Rebuilding relationships ... <br>\n";
    $GLOBALS['log']->info('SugarAide Install: Rebuilding relationships');
    require_once 'data/Relationships/RelationshipFactory.php';
    SugarRelationshipFactory::rebuildCache();

    echo "Performing last quick repair & rebuild ... <br>\n";
    $GLOBALS['log']->info('SugarAide Install: Performing last quick repair & rebuild');

    $autoexecute = false;
    $show_output = false;
    $randc = new RepairAndClear();
    $randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);
}