<?php

$job = BeanFactory::getBean('Schedulers');
$query = new SugarQuery();
$query->from($job);
$query->where()->in('job', array('function::SendUserNews', 'function::CleanUpGCMMessages'));
$query->select(array('id', 'name'));
foreach($query->execute() as $data) {
    $schedulerId = $data['id'];

    if (!empty($schedulerId)) {
        $job->mark_deleted($schedulerId);
        echo "\nRemoving \"{$data['name']}\" Scheduler ... <br>\n";
        $GLOBALS['log']->info('SugarAide Uninstall: Removing \"{$data[\'name\']}\" Scheduler.');
    }
}

echo "Performing a quick repair & rebuild ... <br>\n";
$GLOBALS['log']->info('SugarAide Uninstall: Performing quick repair & rebuild');

$autoexecute = true;
$show_output = false;
require_once("modules/Administration/QuickRepairAndRebuild.php");
$randc = new RepairAndClear();
$randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);
