<?php

require_once 'custom/PxRoutines/NewsFeedLogic/Collector/MobileSync/Helper/MobileSyncContact.php';
require_once 'custom/PxRoutines/NewsFeedLogic/Collector/MobileSync/Helper/MobileSyncActivities.php';

class MobileSync{

	public function __construct(){
	}

	//CONTACT HOOKS START
	public function refreshContactData($bean, $event, $arguments){
		$mobileSyncContact = new MobileSyncContact($bean);
		$this->syncContact($mobileSyncContact, $arguments);
	}
	public function refreshContactRelData($bean, $event, $arguments){
		if(in_array($arguments['link'], array('calls', 'meetings', 'tasks', 'emails', 'archived_emails'))){
			$mobileSyncContact = new MobileSyncContact($bean);

			$activitiesSyncHelper = new MobileSyncActivities($bean);
            MobileSyncActivities::$newActivities[$arguments['related_module']][] = $arguments['related_id'];
			if(!empty(self::$unlinkedRecord)){
				$activitiesSyncHelper->setUnlinkedRecords(self::$unlinkedRecord);
			}
			$mobileSyncContact->setActivities($activitiesSyncHelper);


			$this->syncContact($mobileSyncContact);
		}
	}


	public function deleteContactData($bean, $event, $arguments){
		$mobileSyncContact = new MobileSyncContact($bean);
		$this->syncContact($mobileSyncContact);
	}
	//CONTACT HOOKS END

	//FILTER(SUBSCRIBE|FAVORITE) HOOKS START
	public function setContactAsFollowing($bean, $event, $arguments){

		if(!$bean->deleted && $bean->parent_type == 'Contacts' && !empty($bean->parent_id)){
			$mobileSyncContact = new MobileSyncContact($bean->parent_id);
			$mobileSyncContact->setAdditionalFollowingUsers($bean->created_by);
			$this->syncContact($mobileSyncContact);
		}
	}

	public function setContactAsFavorite($bean, $event, $arguments){

		if(!$bean->deleted && $bean->module == 'Contacts' && !empty($bean->record_id)){
			$this->syncContact(new MobileSyncContact($bean->record_id));
		}
	}
	//FILTER(SUBSCRIBE|FAVORITE) HOOKS END

	protected function getSubscriptions(){
		$query = new SugarQuery();
		$query->from(BeanFactory::getBean('PX_GCMSubscriptions'));
		return $query->execute();
	}

	public function syncContact(MobileSyncContact $mobileSyncContact, $arguments = null, $subscriptions = array()){
		if(empty($subscriptions))
			$subscriptions = $this->getSubscriptions();
		$mobileSyncContact->setHookArguments($arguments);

		foreach($subscriptions as $subscription){
			//ASSIGNED
			if(!empty($subscription['filter_owner']) && $mobileSyncContact->checkOwner($subscription['assigned_user_id'])){
				$this->createNew($subscription, $mobileSyncContact);
				continue;
			}

			//FAVORITE
			if(!empty($subscription['filter_favorite']) && $mobileSyncContact->checkFavorite($subscription['assigned_user_id'])){
				$this->createNew($subscription, $mobileSyncContact);
				continue;
			}

			//FOLLOWING
			if(!empty($subscription['filter_following']) && $mobileSyncContact->checkFollowing($subscription['assigned_user_id'])){
				$this->createNew($subscription, $mobileSyncContact);
				continue;
			}

			//TEAMS
			if(!empty($subscription['filter_team']) && $mobileSyncContact->checkTeams($subscription['assigned_user_id'])){
				$this->createNew($subscription, $mobileSyncContact);
				continue;
			}
		}
	}

	protected function createNew($subscription, $mobileSyncContact){
		$userId = $subscription['assigned_user_id'];
		$message = $mobileSyncContact->getPreparedMessage();
		$parentType = 'Contacts';
		$parentId = $mobileSyncContact->getContact()->id;
		$this->createNewRecord($userId, $message, $parentType, $parentId);
	}

	private function createNewRecord($userId, $message, $parentType, $parentId){
//		$query = new SugarQuery();
//		$query->from(BeanFactory::getBean('PX_UserNews'));
//		$query->where()->equals('parent_id',$parentId);
//		$query->where()->equals('parent_type',$parentType);
//		$query->where()->equals('assigned_user_id',$userId);
//		$query->where()->equals('delivery_channel','mobile_sync');
//		$results = $query->execute();
//
//		$userNewId = $results[0]['id'];
//
//		if(!empty($userNewId))
//			$userNew = BeanFactory::getBean('PX_UserNews', $userNewId);
//
//		if(empty($userNew))

		$userNew = BeanFactory::getBean('PX_UserNews');
		$userNew->assigned_user_id = $userId;
		$userNew->message = $message;
		$userNew->delivery_channel = 'mobile_sync';
		$userNew->message_type = 'mobile_sync';
		$userNew->parent_id = $parentId;
		$userNew->parent_type = $parentType;
		$userNew->save();
	}


	static $repeatedActivitiesInCreate = array();

	public function beforeRefreshContactsActivityData($bean, $event, $arguments){
		if(!empty($bean->repeat_type) && empty($bean->repeat_parent_id)){
			self::$repeatedActivitiesInCreate[$bean->module_name][$bean->id][$bean->id] = array(
				'id' => $bean->id,
				'name' => $bean->name,
				'date_start' => $bean->date_start,
			);
		}elseif(!empty($bean->repeat_type) && !empty($bean->repeat_parent_id)){
			self::$repeatedActivitiesInCreate[$bean->module_name][$bean->repeat_parent_id][$bean->id] = array(
				'id' => $bean->id,
				'name' => $bean->name,
				'date_start' => $bean->date_start,
			);
		}
	}


	//RELATED HOOKS START
	static $contact_guest_list = array();

	public function rememberContactList($bean, $event, $arguments){

		if($arguments['related_module'] == 'Contacts' && !empty($arguments['related_id'])){
			self::$contact_guest_list[$arguments['id']][] = $arguments['related_id'];
		}



	}
	public function refreshContactsActivityData($bean, $event, $arguments){

		$bean->load_relationship('contacts');

		$contacts = $bean->contacts->getBeans();
		if($bean->parent_type == 'Contacts' && !empty($bean->parent_id)){
			$included = 0;
			foreach($contacts as $contact){
				if($contact->id == $bean->parent_id)
					$included = 1;
			}

			if(!$included){
				$contacts[] = BeanFactory::getBean('Contacts', $bean->parent_id);
			}

		}

		foreach($contacts as $contact){

			if(!empty(self::$repeatedActivitiesInCreate[$bean->module_name])){
				$activityList = array();
				if(empty($bean->repeat_parent_id) && !empty(self::$repeatedActivitiesInCreate[$bean->module_name][$bean->id])){
					$activityList = self::$repeatedActivitiesInCreate[$bean->module_name][$bean->id];
					self::$repeatedActivitiesInCreate[$bean->module_name][$bean->id][$bean->id]['contact_ids'][] = $contact->id;
				}

				$newActivities = array();
				foreach($activityList as $activity){
					$newActivities[$bean->module_name][$activity['id']] = array(
						'id' => $activity['id'],
						'name' => $activity['name'],
						'activity_date' => $activity['date_start'],
					);
				}
			}

			$contactSyncHelper = new MobileSyncContact($contact);
			$activitiesSyncHelper = new MobileSyncActivities($contact);
			if(!empty($newActivities)){
				//$contactSyncHelper->setActivities(
				$activitiesSyncHelper->setLinkedRepeatedActivities($newActivities);
				//);
			}

			if(!empty(self::$unlinkedRecord)){
				$activitiesSyncHelper->setUnlinkedRecords(self::$unlinkedRecord);
			}
			$contactSyncHelper->setActivities($activitiesSyncHelper);

			$this->syncContact($contactSyncHelper);
		}

		//during create and linking
		if(!empty($bean->repeat_parent_id) && !empty(self::$repeatedActivitiesInCreate[$bean->module_name][$bean->repeat_parent_id])){
			$activityList = self::$repeatedActivitiesInCreate[$bean->module_name][$bean->repeat_parent_id];
			$newActivities = array();
			foreach($activityList as $activity){
				$newActivities[$bean->module_name][$activity['id']] = array(
					'id' => $activity['id'],
					'name' => $activity['name'],
					'activity_date' => $activity['date_start'],
				);
			}
			$contactIds = self::$repeatedActivitiesInCreate[$bean->module_name][$bean->repeat_parent_id][$bean->repeat_parent_id]['contact_ids'];

			foreach($contactIds as $contactId){

				$contact = BeanFactory::getBean('Contacts', $contactId);

				$contactSyncHelper = new MobileSyncContact($contact);
				$activitiesSyncHelper = new MobileSyncActivities($contact);
				if(!empty($newActivities)){
					$activitiesSyncHelper->setLinkedRepeatedActivities($newActivities);
					$contactSyncHelper->setActivities($activitiesSyncHelper);
				}
				$this->syncContact($contactSyncHelper);
			}
		}

		//during unlink
		if(!empty($bean->repeat_parent_id) && !empty(self::$contact_guest_list[$bean->repeat_parent_id])){
			$contactIds = self::$contact_guest_list[$bean->repeat_parent_id];

			self::$unlinkedRecord[$bean->id] = array(
				'id' => $bean->id,
				'module' => $bean->module_name
			);

			foreach($contactIds as $contactId){

				$contact = BeanFactory::getBean('Contacts', $contactId);

				$contactSyncHelper = new MobileSyncContact($contact);
				$activitiesSyncHelper = new MobileSyncActivities($contact);
				$contactSyncHelper->setActivities(
					$activitiesSyncHelper->setUnlinkedRecords(self::$unlinkedRecord)
				);


				$this->syncContact($contactSyncHelper);
			}
		}
	}

	static $unlinkedRecord = array();

	public function unlinkContactsActivityData($bean, $event, $arguments){

		if($arguments['related_module'] == 'Contacts' && !empty($arguments['related_id'])){

			self::$unlinkedRecord[$arguments['id']] = array(
				'id' => $arguments['id'],
				'module' => $arguments['module']
			);

			$contact = BeanFactory::getBean($arguments['related_module'], $arguments['related_id']);
			$contactSyncHelper = new MobileSyncContact($contact);
			$activitiesSyncHelper = new MobileSyncActivities($contact);
			$contactSyncHelper->setActivities(
				$activitiesSyncHelper->setUnlinkedRecords(self::$unlinkedRecord)
			);

			$this->syncContact($contactSyncHelper);
		}
	}

	public function deleteActivityData($bean, $event, $arguments){
		$bean->load_relationship('contacts');

		foreach($bean->contacts->getBeans() as $contact){

			self::$unlinkedRecord[$bean->id] = array(
				'id' => $bean->id,
				'module' => $bean->module_name
			);

			$contactSyncHelper = new MobileSyncContact($contact);
			$activitiesSyncHelper = new MobileSyncActivities($contact);
			$contactSyncHelper->setActivities(
				$activitiesSyncHelper->setUnlinkedRecords(self::$unlinkedRecord)
			);

			$this->syncContact($contactSyncHelper);
		}
	}
	//RELATED HOOKS END
}