<?php

class MobileNotify{
	protected $proxy;
	protected $proxyAuth;

	public function __construct(){

		$proxy_config = Administration::getSettings('proxy');

		if( !empty($proxy_config) &&
			!empty($proxy_config->settings['proxy_on']) &&
			$proxy_config->settings['proxy_on'] == 1) {

			$this->proxy = $proxy_config->settings['proxy_host'] .':'. $proxy_config->settings['proxy_port'];

			if(!empty($proxy_config->settings['proxy_auth']))
				$this->proxyAuth = $proxy_config->settings['proxy_username'] .':'. $proxy_config->settings['proxy_password'];
		}

	}

	public function sendNotification($gcmregistrations){
		$tokens = array();
		foreach($gcmregistrations as $gcmRegistration)
		{
			$tokens[] = $gcmRegistration['registration_token'];
		}

		$tokensChunks = array_chunk($tokens, 1000);
		foreach ($tokensChunks as $tokensChunk) {
			$pushStatus = $this->sendPushNotification($tokensChunk);
		}
	}
	public function sendPushNotification($registration_ids){
		define("GOOGLE_API_URL", "https://gcm-http.googleapis.com/gcm/send");
		define("GOOGLE_API_KEY", "AIzaSyCdzR2bZDw1Np1hZBDASCd1b1XLHRw70Ek");

		$fields = array('registration_ids' => $registration_ids, 'data' => array('type'=>'SOME TYPE', 'message' => 'MESSAGE')) ;
		$headers = array('Authorization:key=' . GOOGLE_API_KEY, 'Content-Type: application/json');

		//$GLOBALS['log']->fatal("mdtest: ". json_encode($fields));

		$ch = curl_init();

		curl_setopt($ch, CURLOPT_URL, GOOGLE_API_URL);

		if(!empty($this->proxy))
			curl_setopt($ch, CURLOPT_PROXY, $this->proxy);
		if(!empty($this->proxyAuth))
			curl_setopt($ch, CURLOPT_PROXYUSERPWD, $this->proxyAuth);

		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		curl_exec($ch);

		curl_close($ch);
	}

}