<?php


class SendNews{

	protected $news = array();

	public function __construct(){

	}

	public function send(){
		$this->getUserNews();

		$news = $this->collectTypes();

		foreach($news as $group => $newsGroup){
			$provider = $this->loadGroup($group);
			if(!empty($provider))
				$provider->send($newsGroup);
		}
	}

	protected function loadGroup($groupName){
		switch($groupName){
			case 'mobile_ban_user':
				require_once 'custom/PxRoutines/NewsFeedLogic/Provider/MobileBanProvider.php';
				return new MobileBanProvider();
				break;
			case 'mobile_sync':
				require_once 'custom/PxRoutines/NewsFeedLogic/Provider/MobileProvider.php';
				return new MobileProvider();
				break;
		}
		return null;
	}

	protected function getUserNews(){
		$query = new SugarQuery();
		$query->from(BeanFactory::getBean('PX_UserNews'));
		$query->select(array('*'));
		$query->orderBy('date_entered', 'asc');
		$this->news = $query->execute();
	}

	protected function collectTypes(){
		$news = array(
			'mobile_sync' => array(),
			'mobile_ban_user' => array()
		);


		foreach($this->news as $new){
			if($new['delivery_channel'] == 'mobile_sync'){
				if($new['message_type'] == 'ban')
					$news['mobile_ban_user'][] = $new;
				else
					$news['mobile_sync'][] = $new;
			}
		}

		return $news;
	}
}