<?php

require_once('include/api/SugarApi.php');

class PxGetUserInfoApi extends SugarApi
{
    public function registerApiRest()
    {
        return array(
            'PxGetUserInfo' => array(
                'reqType' => 'POST',
                'path' => array('PxGetUserInfo'),
                'pathVars' => array(''),
                'method' => 'GetUserInfo',
                'shortHelp' => 'Retrieve user info for Signature in Feedback mail',
                'longHelp' => '',
            ),
        );
    }

    public function GetUserInfo($api, $args)
    {
        $data = array();
        $user_id = $args['uid'];

        if(!empty($user_id)){
            $user = BeanFactory::getBean('Users', $user_id, array('disable_row_level_security' => true));
            if($user){
                $data['full_name'] = $user->full_name;
                $data['phone_work'] = $user->phone_work;

				foreach($user->emailAddress->getAddressesForBean($user) as $email_data){
					$data['emails'][] = '<a href="mailto:'.$email_data['email_address'].'">'.$email_data['email_address'].'</a>';
				}


                $data['emails'] = implode(', ', $data['emails']);
            }
        }

        return $data;

    }
}