({
    extendsFrom: 'EmailsComposeView',

    //<px_change author="Pavlo Chumachenko" date="2016-05-18" desc="#19057">
    initialize: function(options) {
        this._super('initialize', [options]);
        this.events = _.extend({}, this.events, {
            'click .px-feedback a': 'updateEmailBody'
        });
    },
    //</px_change>

    _render: function(){
        this._super('_render');
        if (this.createMode) {
            this.setTitle(app.lang.get('LBL_PX_COMPOSE_FEEDBACK_TITLE', this.module));
        }
        // Add User Signature
        this.getSignatureInfo();
    },

    updateEmailBody: function(event){
        event.preventDefault();
        event.stopImmediatePropagation();

        //Update email text
        var current = (!_.isUndefined(this.model.get('html_body'))) ? this.model.get('html_body') : '',
            text = $(event.target).attr('data-text') + "<br/>";

        this.model.set('html_body', text + current);

        // Toogle checkbox
        _.defer(function() {
            $(event.target).attr('checked', !$(event.target).attr('checked'));
        });
    },

    getSignatureInfo: function(){
        app.alert.show('px-get-user-data', {level: 'process', title: app.lang.get('LBL_LOADING'), autoClose: false});

        var url = app.api.buildURL('', 'PxGetUserInfo');

        app.api.call('create', url, {uid: app.user.id}, {
            success: _.bind(function (data) {
                if(data){
                    this.user = data;
                    this.addSignature();
                }
            }, this),
            error: function(){
                app.alert.show('px-fail-user-data', {level: 'error', autoClose: true, autoCloseDelay: 2000, title: app.lang.get("LBL_PX_CANNOT_LOAD_USER_DATA", 'Emails')});
            },
            complete: function(){
                app.alert.dismiss('px-get-user-data');
            }
        });
    },

    addSignature: function(){
        var email_body = this.model.get('html_body') || '',
            signature_open_tag = '<br class="signature-begin" />',
            signature_close_tag = '<br class="signature-end" />',
            signature_body = app.lang.get('LBL_PX_FEEDBACK_SIGNATURE', 'Emails');

        if(this.user){
            signature_body = signature_body.replace('{{full_name}}', this.user.full_name);
            signature_body = signature_body.replace('{{emails}}', this.user.emails);
            signature_body = signature_body.replace('{{phone_work}}', this.user.phone_work);
            var signature = signature_open_tag + signature_body + signature_close_tag;

            this.model.set('html_body', email_body + signature);
        }
    }
})
