<?php

/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/06_Customer_Center/10_Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */

$dictionary['PX_GCMMessages'] = array(
	'table' => 'px_gcmmessages',
	'audited' => true,
	'activity_enabled' => false,
	'duplicate_merge' => true,
	'fields' => array(
		'message_type' =>
			array(
				'required' => false,
				'name' => 'message_type',
				'vname' => 'LBL_MESSAGE_TYPE',
				'type' => 'enum',
				'massupdate' => true,
				'default' => '',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'enabled',
				'duplicate_merge_dom_value' => '1',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'len' => 100,
				'size' => '20',
				'options' => 'account_type_dom',
				'dependency' => false,
			),
		'message' =>
			array(
				'required' => false,
				'name' => 'message',
				'vname' => 'LBL_MESSAGE',
				'type' => 'text',
				'massupdate' => false,
				'default' => '',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'enabled',
				'duplicate_merge_dom_value' => '1',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'full_text_search' =>
					array(
						'boost' => '0',
						'enabled' => false,
					),
				'calculated' => false,
				'size' => '20',
				'studio' => 'visible',
				'rows' => '4',
				'cols' => '20',
			),
		'gcm_message_code' =>
			array(
				'required' => false,
				'name' => 'gcm_message_code',
				'vname' => 'LBL_GCM_MESSAGE_CODE',
				'type' => 'varchar',
				'massupdate' => false,
				'default' => '',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'enabled',
				'duplicate_merge_dom_value' => '1',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'full_text_search' =>
					array(
						'boost' => '0',
						'enabled' => false,
					),
				'calculated' => false,
				'len' => '255',
				'size' => '20',
			),
		'gcmregistrations' =>
			array(
				'name' => 'gcmregistrations',
				'type' => 'link',
				'relationship' => 'px_gcmregistrations_px_gcmmessages',
				'source' => 'non-db',
				'side' => 'right',
				'vname' => 'LBL_GCMREGISTRATIONS',
			),
		'gcmregistration_id' => array(
			'required' => false,
			'name' => 'gcmregistration_id',
			'vname' => 'LBL_GCMREGISTRATION_ID',
			'type' => 'id',
			'massupdate' => 0,
			'no_default' => false,
			'comments' => '',
			'help' => '',
			'importable' => 'true',
			'duplicate_merge' => 'disabled',
			'duplicate_merge_dom_value' => 0,
			'audited' => false,
			'reportable' => false,
			'unified_search' => false,
			'merge_filter' => 'disabled',
			'calculated' => false,
			'len' => 36,
			'size' => '20',
		),
		'gcmregistration_name' => array(
			'required' => true,
			'source' => 'non-db',
			'name' => 'gcmregistration_name',
			'vname' => 'LBL_GCMREGISTRATION_NAME',
			'type' => 'relate',
			'massupdate' => 0,
			'no_default' => false,
			'comments' => '',
			'help' => '',
			'importable' => 'true',
			'duplicate_merge' => 'disabled',
			'duplicate_merge_dom_value' => '0',
			'audited' => true,
			'reportable' => true,
			'unified_search' => false,
			'merge_filter' => 'disabled',
			'calculated' => false,
			'len' => '255',
			'size' => '20',
			'link' => 'gcmregistrations',
			'id_name' => 'gcmregistration_id',
			'module' => 'PX_GCMRegistrations',
			'rname' => 'name',
			'quicksearch' => 'enabled',
			'studio' => 'visible',
			'readonly' => false,
		),

		'parent_type' =>
			array(
				'name' => 'parent_type',
				'vname' => 'LBL_PARENT_TYPE',
				'type' => 'varchar',
				'required' => false,
				'len' => 255,
				'studio' => array('wirelesslistview' => false),
				'comment' => 'The Sugar object to which the call is related'
			),
		'parent_id' =>
			array(
				'name' => 'parent_id',
				'vname' => 'LBL_LIST_RELATED_TO_ID',
				'type' => 'id',
				'reportable' => false,
				'comment' => 'The ID of the parent Sugar object identified by parent_type'
			),
		'message_time' => array (
			'name' => 'message_time',
			'vname' => 'LBL_MESSAGE_TIME',
			'type' => 'datetime',
			'required' => true,
			'comment' => 'Datetime message created'
		),
	),
	'indices' => array(
		'idx_px_gcmmessages_registration_del' => array(
			'name' => 'idx_px_gcmmessages_registration_del',
			'type' => 'index',
			'fields' => array('gcmregistration_id', 'deleted')
		),
		'idx_px_gcmmessages_assigned_user_id' => array(
			'name' => 'idx_px_gcmmessages_assigned_user_id',
			'type' => 'index',
			'fields' => array('assigned_user_id')
		),
		'idx_px_gcmmessages_assigned_registrations' => array(
			'name' => 'idx_px_gcmmessages_assigned_registrations',
			'type' => 'index',
			'fields' => array('assigned_user_id', 'gcmregistration_id', 'message_time', 'deleted')
		),
		'idx_px_gcmmessages_parent' => array(
			'name' => 'idx_px_gcmmessages_parent',
			'type' => 'index',
			'fields' => array('parent_id', 'parent_type', 'deleted')
		),
	),
	'relationships' => array(
		'px_gcmregistrations_px_gcmmessages' =>
			array(
				'lhs_module' => 'PX_GCMRegistrations',
				'lhs_table' => 'px_gcmregistrations',
				'lhs_key' => 'id',
				'rhs_module' => 'PX_GCMMessages',
				'rhs_table' => 'px_gcmmessages',
				'rhs_key' => 'gcmregistration_id',
				'relationship_type' => 'one-to-many',
			)
	),
	'optimistic_locking' => true,
	'unified_search' => true,
);

if (!class_exists('VardefManager')) {
	require_once 'include/SugarObjects/VardefManager.php';
}
VardefManager::createVardef('PX_GCMMessages', 'PX_GCMMessages', array('basic', 'assignable'));