<?php

require_once 'include/api/SugarApi.php';

class PxChangeRegistrationStatusApi extends SugarApi {

	public function registerApiRest()
	{
		return array(
			'changeGCMRegistrationStatus' => array(
				'reqType' => 'POST',
				'path' => array('changeGCMRegistrationStatus'),
				'pathVars' => array(''),
				'method' => 'changeGCMRegistrationStatus',
			),
		);
	}

//	public function setMassUserBanned(ServiceBase $api, array $args){
//
//		if(is_array($args['registration_ids']) && !empty($args['registration_ids'])){
//			foreach($args['registration_ids'] as $registration_id){
//				//$this->setUserBanned($api, array('registration_id', $registration_id));
//
//				$registration = $this->getDeviceRegistration($registration_id);
//				$registration = $this->setRegistrationInactive($registration, $args['status']);
//				$newsId = $this->createUserNew($registration);
//			}
//		}
//
//		return array(
//			'success' => true
//		);
//	}

	public function changeGCMRegistrationStatus(ServiceBase $api, array $args){

		if(is_array($args['registration_ids']) && !empty($args['registration_ids'])){
			foreach($args['registration_ids'] as $registrationId){
				$this->processStatusModification($registrationId, $args['is_deactivated']);
			}
		}else{
			$this->processStatusModification($args['registration_id'], $args['is_deactivated']);
		}
//		$registration = $this->getDeviceRegistration($args['registration_id']);
//		$registration = $this->setRegistrationInactive($registration, $args['is_deactivated']);
//
//		$newsId = $this->createUserNew($registration);
		return array(
			'success' => !empty($newsId)
		);
	}

	protected function processStatusModification($registrationId, $isDeactivated){
		$registration = $this->getDeviceRegistration($registrationId, $isDeactivated);
		$registration = $this->setRegistrationInactive($registration, $isDeactivated);

		return $this->createUserNew($registration);
	}

	protected function getDeviceRegistration($registrationId){
		if(empty($registrationId)){
			return null;
		}
		$registration = BeanFactory::getBean('PX_GCMRegistrations', $registrationId);
		return $registration;
	}

	protected function setRegistrationInactive($registration, $isDeactivated){
		$status_mapping = array(
			0 => 'active',
			1 => 'inactive'
		);
		if(empty($registration) || !isset($isDeactivated) || $registration->status == $status_mapping[$isDeactivated]){
			return null;
		}
		$registration->status = $status_mapping[$isDeactivated];
		$registration->save();

		return $registration;
	}

	protected function createUserNew($registration){

		if(empty($registration))
			return null;

		if(empty($registration->status)){
			//DELETE ALL NEWS FOR USER DEACTIVATING
			$query = new SugarQuery();
			$query->from(BeanFactory::getBean('PX_UserNews'));
			$query->where()->equals('parent_id',$registration->id);
			$query->where()->equals('parent_type',$registration->module_dir);
			$query->where()->equals('assigned_user_id',$registration->assigned_user_id);
			$query->where()->equals('message_type','ban');
			foreach($query->execute() as $px_baneUserNews){
				BeanFactory::getBean('PX_UserNews')->mark_deleted($px_baneUserNews['id']);
			}


			$query = new SugarQuery();
			$query->from(BeanFactory::getBean('PX_GCMMessages'));
			$query->where()->equals('gcmregistration_id',$registration->id);
			foreach($query->execute() as $px_gcmmessage){
				BeanFactory::getBean('PX_GCMMessages')->mark_deleted($px_gcmmessage['id']);
			}

			require_once 'custom/clients/base/api/PxGCMApi.php';
			$PxGCMApi = new PxGCMApi();
			$PxGCMApi->publishSubscribedContactsForUser($registration->assigned_user_id, $registration->id);
			return true;
		}else{
			$query = new SugarQuery();
			$query->from(BeanFactory::getBean('PX_UserNews'));
			$query->where()->equals('parent_id',$registration->id);
			$query->where()->equals('parent_type',$registration->module_dir);
			$query->where()->equals('assigned_user_id',$registration->assigned_user_id);
			$query->where()->equals('delivery_channel','mobile_sync');
			$results = $query->execute();

			$userNewId = $results[0]['id'];

			if(!empty($userNewId))
				$userNew = BeanFactory::getBean('PX_UserNews', $userNewId);

			if(empty($userNew))
				$userNew = BeanFactory::getBean('PX_UserNews');

			$userNew->assigned_user_id = $registration->assigned_user_id;
			$userNew->message = '';
			$userNew->delivery_channel = 'mobile_sync';
			$userNew->message_type = 'ban';
			$userNew->px_newsfeed_id = '';
			$userNew->parent_id = $registration->id;
			$userNew->parent_type = $registration->module_dir;
			$userNew->save();

			return $userNew->id;
		}
	}

}