({
    extendsFrom: 'MassupdateView',

    CONST_DEACTIVATE_REGISTRATION_FLAG: 1,
    CONST_DEACTIVATE_REGISTRATION_MSG: 'CONFIRM_DEACTIVATE_REGISTRATION_MSG',

    initialize: function (options) {
        this._super('initialize', [options]);
    },


    delegateListFireEvents: function() {
        this._super('delegateListFireEvents');

        this.layout.on("list:px_mass_deactivate_registration:fire", this.pxDeactivateRegistration, this);
    },

    pxDeactivateRegistration: function () {
        this.pxChangeRegistrationStatus(this.CONST_DEACTIVATE_REGISTRATION_FLAG, this.CONST_DEACTIVATE_REGISTRATION_MSG);
    },

    pxChangeRegistrationStatus: function(isDeactivated, confirmMessage){
        var self = this;

        app.alert.show('change_registration_status_confirm', {
            level: 'confirmation',
            messages: app.lang.get(confirmMessage, this.module),
            onConfirm: function(){
                self.pxChangeRegistrationStatusApiCall(isDeactivated);
            }
        });

    },

    pxChangeRegistrationStatusApiCall: function(isDeactivated){
        this.hideAll();

        var registrations = this.context.get("mass_collection");
        var banUserUrl = app.api.buildURL('changeGCMRegistrationStatus');
        app.api.call('create', banUserUrl,
            {
                registration_ids: registrations.pluck('id'),
                is_deactivated: isDeactivated
            },
            {
                success: _.bind(function (response) {
                    app.alert.dismiss('px_ban_process');
                    app.alert.show('px_ban_result', {level: 'success', autoClose: true});
                    app.router.refresh();
                    return;
                }),
                error: _.bind(function () {
                    app.alert.dismiss('px_ban_process');
                    app.alert.show('px_ban_result', {level: 'error', autoClose: true});
                    return;
                })
            });
        app.alert.show('px_ban_process', {level: 'process'});
    }
})
