<?php
$module_name = 'PX_GCMRegistrations';
$viewdefs[$module_name]['base']['view']['record'] = array(
	'buttons' => array(
		array(
			'type' => 'button',
			'name' => 'cancel_button',
			'label' => 'LBL_CANCEL_BUTTON_LABEL',
			'css_class' => 'btn-invisible btn-link',
			'showOn' => 'edit',
			'events' => array(
				'click' => 'button:cancel_button:click',
			),
		),

		array(
			'type' => 'button',
			'name' => 'px_deactivate_registration_button',
			'label' => 'LBL_PX_DEACTIVATE_REGISTRATION_BUTTON',
			'css_class' => 'btn btn-primary',
			'events' => array(
				'click' => 'button:px_deactivate_registration:click',
			),
			'showOn' => 'view',
			'acl_action' => 'edit',
		),
//		array(
//			'type' => 'button',
//			'name' => 'px_activate_registration_button',
//			'label' => 'LBL_PX_ACTIVATE_REGISTRATION_BUTTON',
//			'css_class' => 'btn btn-primary',
//			'events' => array(
//				'click' => 'button:px_activate_registration:click',
//			),
//			'showOn' => 'view',
//			'acl_action' => 'edit',
//		),
		array(
			'type' => 'rowaction',
			'event' => 'button:save_button:click',
			'name' => 'save_button',
			'label' => 'LBL_SAVE_BUTTON_LABEL',
			'css_class' => 'btn btn-primary',
			'showOn' => 'edit',
			'acl_action' => 'edit',
		),
		array(
			'type' => 'actiondropdown',
			'name' => 'main_dropdown',
			'primary' => true,
			'showOn' => 'view',
			'buttons' => array(
				array(
					'type' => 'rowaction',
					'event' => 'button:edit_button:click',
					'name' => 'edit_button',
					'label' => 'LBL_EDIT_BUTTON_LABEL',
					'acl_action' => 'edit',
				),
				array(
					'type' => 'shareaction',
					'name' => 'share',
					'label' => 'LBL_RECORD_SHARE_BUTTON',
					'acl_action' => 'view',
				),
				array(
					'type' => 'pdfaction',
					'name' => 'download-pdf',
					'label' => 'LBL_PDF_VIEW',
					'action' => 'download',
					'acl_action' => 'view',
				),
				array(
					'type' => 'pdfaction',
					'name' => 'email-pdf',
					'label' => 'LBL_PDF_EMAIL',
					'action' => 'email',
					'acl_action' => 'view',
				),
				array(
					'type' => 'divider',
				),
				array(
					'type' => 'rowaction',
					'event' => 'button:find_duplicates_button:click',
					'name' => 'find_duplicates_button',
					'label' => 'LBL_DUP_MERGE',
					'acl_action' => 'edit',
				),
				array(
					'type' => 'rowaction',
					'event' => 'button:duplicate_button:click',
					'name' => 'duplicate_button',
					'label' => 'LBL_DUPLICATE_BUTTON_LABEL',
					'acl_module' => $module_name,
					'acl_action' => 'create',
				),
				array(
					'type' => 'divider',
				),
				array(
					'type' => 'rowaction',
					'event' => 'button:delete_button:click',
					'name' => 'delete_button',
					'label' => 'LBL_DELETE_BUTTON_LABEL',
					'acl_action' => 'delete',
				),
			),
		),
		array(
			'name' => 'sidebar_toggle',
			'type' => 'sidebartoggle',
		),
	),
	'panels' => array(
		array(
			'name' => 'panel_header',
			'label' => 'LBL_RECORD_HEADER',
			'header' => true,
			'fields' => array(
				array(
					'name' => 'picture',
					'type' => 'avatar',
					'width' => 42,
					'height' => 42,
					'dismiss_label' => true,
					'readonly' => true,
				),
				'name',
				array(
					'name' => 'favorite',
					'label' => 'LBL_FAVORITE',
					'type' => 'favorite',
					'readonly' => true,
					'dismiss_label' => true,
				),
				array(
					'name' => 'follow',
					'label' => 'LBL_FOLLOW',
					'type' => 'follow',
					'readonly' => true,
					'dismiss_label' => true,
				),
			),
		),
		array(
			'name' => 'panel_body',
			'label' => 'LBL_RECORD_BODY',
			'columns' => 2,
			'labelsOnTop' => true,
			'placeholders' => true,
			'newTab' => false,
			'panelDefault' => 'expanded',
			'fields' => array(
				array(
					'name' => 'assigned_user_name',
					'span' => 12,
				),
				array(
					'name' => 'registration_token',
					'studio' => 'visible',
					'label' => 'LBL_REGISTRATION_TOKEN',
					'span' => 12,
				),
				'status',
			),
		),
		array(
			'name' => 'panel_hidden',
			'label' => 'LBL_SHOW_MORE',
			'hide' => true,
			'columns' => 2,
			'labelsOnTop' => true,
			'placeholders' => true,
			'newTab' => false,
			'panelDefault' => 'expanded',
			'fields' => array(
				array(
					'name' => 'gcm_instance',
					'studio' => 'visible',
					'label' => 'LBL_GCM_INSTANCE',
					'span' => 12,
				),
				array(
					'name' => 'description',
					'span' => 12,
				),
				array(
					'name' => 'date_modified_by',
					'readonly' => true,
					'inline' => true,
					'type' => 'fieldset',
					'label' => 'LBL_DATE_MODIFIED',
					'fields' => array(
						array(
							'name' => 'date_modified',
						),
						array(
							'type' => 'label',
							'default_value' => 'LBL_BY',
						),
						array(
							'name' => 'modified_by_name',
						),
					),
				),
				array(
					'name' => 'date_entered_by',
					'readonly' => true,
					'inline' => true,
					'type' => 'fieldset',
					'label' => 'LBL_DATE_ENTERED',
					'fields' => array(
						array(
							'name' => 'date_entered',
						),
						array(
							'type' => 'label',
							'default_value' => 'LBL_BY',
						),
						array(
							'name' => 'created_by_name',
						),
					),
				),
			),
		),
	),
	'templateMeta' => array(
		'useTabs' => false,
	),
);
