({
    extendsFrom: 'RecordlistView',

    CONST_DEACTIVATE_REGISTRATION_FLAG: 1,
    CONST_DEACTIVATE_REGISTRATION_MSG: 'CONFIRM_DEACTIVATE_REGISTRATION_MSG',
    CONST_ACTIVATE_REGISTRATION_FLAG: 0,
    CONST_ACTIVATE_REGISTRATION_MSG: 'CONFIRM_ACTIVATE_REGISTRATION_MSG',

    initialize: function (options) {
        _.extend(this.contextEvents, {"list:px_deactivate_registration:fire": "pxDeactivateRegistration"});
        this._super('initialize', [options]);
    },


    pxDeactivateRegistration: function (model) {
        this.pxChangeRegistrationStatus(model, this.CONST_DEACTIVATE_REGISTRATION_FLAG, this.CONST_DEACTIVATE_REGISTRATION_MSG);
    },

    pxActivateRegistration: function(model) {
        this.pxChangeRegistrationStatus(model, this.CONST_ACTIVATE_REGISTRATION_FLAG, this.CONST_ACTIVATE_REGISTRATION_MSG);
    },

    pxChangeRegistrationStatus: function(model, isDeactivated, confirmMessage){
        var self = this;
        app.alert.show('change_registration_status_confirm', {
            level: 'confirmation',
            messages: app.lang.get(confirmMessage, this.module),
            onConfirm: function(){
                self.pxChangeRegistrationStatusApiCall(model, isDeactivated);
            }
        });

    },

    pxChangeRegistrationStatusApiCall: function(model, isDeactivated){
        var banUserUrl = app.api.buildURL('changeGCMRegistrationStatus');
        app.api.call('create', banUserUrl,
            {
                registration_id: model.get('id'),
                is_deactivated: isDeactivated
            },
            {
                success: _.bind(function (response) {
                    app.alert.dismiss('px_ban_process');
                    app.alert.show('px_ban_result', {level: 'success', autoClose: true});
                    app.router.refresh();
                    return;
                }),
                error: _.bind(function () {
                    app.alert.dismiss('px_ban_process');
                    app.alert.show('px_ban_result', {level: 'error', autoClose: true});
                    return;
                })
            });
        app.alert.show('px_ban_process', {level: 'process'});
    }
})
