<?PHP
/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/06_Customer_Center/10_Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */
/**
 * THIS CLASS IS FOR DEVELOPERS TO MAKE CUSTOMIZATIONS IN
 */
require_once('modules/PX_GCMSubscriptions/PX_GCMSubscriptions_sugar.php');
require_once 'custom/PxRoutines/NewsFeedLogic/Collector/MobileReSync.php';

class PX_GCMSubscriptions extends PX_GCMSubscriptions_sugar {

	public $reloadMessages = true;
	/**
	 * This is a depreciated method, please start using __construct() as this method will be removed in a future version
     *
     * @see __construct
     * @depreciated
	 */
	function PX_GCMSubscriptions(){
		self::__construct();
	}

	public function __construct(){
		parent::__construct();
	}

	public function save($check_notify = false)
	{
		$isUpdate = true;
		if(empty($this->id) || !empty($this->new_with_id)) {
			$isUpdate = false;
		}
		$fetched_row = $this->fetched_row;

		if(empty($this->name)){

			if(empty($this->assigned_user_name)){
				$assigned_user = BeanFactory::getBean('Users', $this->assigned_user_id);
				if(!empty($assigned_user))
					$this->assigned_user_name = $assigned_user->full_name;
			}

			$this->name = $this->assigned_user_name;
		}

		$id = parent::save($check_notify);

		$mobileReSync = new MobileReSync();
		if($this->checkDeleteCondition())
			$mobileReSync->cleanUpAllUserMessages($this->dataChanges['assigned_user_id']['before']);

		if($this->reloadMessages && (!$isUpdate || $this->checkRefreshCondition($fetched_row))){
			$mobileReSync->refreshSubscribedContactsByUser($this->assigned_user_id);
		}

		return $id;
	}

	public function mark_deleted($id){

		if(!empty($id)){
			$gcmSubscription = BeanFactory::getBean('PX_GCMSubscriptions', $id);
			$mobileReSync = new MobileReSync();
			$mobileReSync->cleanUpAllUserMessages($gcmSubscription->assigned_user_id);
		}


		return parent::mark_deleted($id);
	}

	protected function checkDeleteCondition(){
		return !empty($this->dataChanges['assigned_user_id']) && $this->dataChanges['assigned_user_id']['before'] != $this->dataChanges['assigned_user_id']['after'];
	}

	protected function checkRefreshCondition($fetched_row){
		return
			!empty($this->assigned_user_id) && (
				$fetched_row['filter_owner'] != $this->filter_owner ||
				$fetched_row['filter_favorite'] != $this->filter_favorite ||
				$fetched_row['filter_following'] != $this->filter_following ||
				$fetched_row['filter_team'] != $this->filter_team ||
				$fetched_row['assigned_user_id'] != $this->assigned_user_id
			);
	}

}