<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/06_Customer_Center/10_Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */

require_once 'clients/base/api/DuplicateCheckApi.php';

class PX_GCMSubscriptionsDuplicateCheckApi extends DuplicateCheckApi
{
    public function registerApiRest()
    {
        return array(
            'duplicateCheck' => array(
                'reqType' => 'POST',
                'path' => array('PX_GCMSubscriptions','duplicateCheck'),
                'pathVars' => array('module',''),
                'method' => 'checkForDuplicates',
                'shortHelp' => 'Check for duplicate records within a module',
                'longHelp' => 'include/api/help/module_duplicatecheck_post_help.html',
            ),
        );
    }

    /**
     * Using the appropriate duplicate check service, search for duplicates in the system
     * TODO: we should refactor some of the bean loading in SugarApi so we can move some of this logic there
     *
     * @param ServiceBase $api
     * @param array $args
     */
    function checkForDuplicates(ServiceBase $api, array $args)
    {
		$recordId = $this->extractRecordId($args);
		$duplicates = parent::checkForDuplicates($api, $args);

		return $this->extractCurrentRecord($recordId, $duplicates);

    }

	protected function extractRecordId(&$args){
		if(!empty($args['id'])){
			$recordId = $args['id'];
			unset($args['id']);
			return $recordId;
		}
		return '';
	}

	protected function extractCurrentRecord($recordId, $duplicates){
		if($this->isDupListEmpty($duplicates)){
			foreach($duplicates['records'] as $key => $duplicateItem){
				if($duplicateItem['id'] == $recordId)
					unset($duplicates['records'][$key]);
			}
		}

		return $duplicates;
	}

	protected function isDupListEmpty($duplicates){
		return !empty($duplicates) && !empty($duplicates['records']) && count($duplicates['records']) > 0;
	}
}
