({
    extendsFrom: 'RecordView',

    initialize: function (options) {
        this._super('initialize', [options]);

        error_string = app.lang.get('ERR_PX_GCMSUBSCRIPTIONS_DUPLICATE', this.module);
        app.error.errorName2Keys['px_has_duplicates_error'] = error_string;
        this.model.addValidationTask('check_unique', _.bind(this._checkDuplicates, this));
    },


    _checkDuplicates: function (fields, errors, callback) {
        var self = this;

        var priority_check_unique_request = app.api.buildURL(self.module, 'duplicateCheck');
        app.api.call('create', priority_check_unique_request,
            {
                module: self.module,
                id: self.model.get('id'),
                assigned_user_id: self.model.get('assigned_user_id')
            },
            {
                success: _.bind(function (response) {

                    if(response.records.length > 0) {
                        errors['assigned_user_name'] = errors['assigned_user_name'] || {};
                        errors['assigned_user_name'].px_has_duplicates_error = true;
                        callback(null, fields, errors);
                    } else
                        callback(null, fields, errors);

                    return;
                }),
                error: _.bind(function () {
                    return;
                })
            });
    }


})