<?php

/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/06_Customer_Center/10_Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */

$dictionary['PX_GCMSubscriptions'] = array(
	'table' => 'px_gcmsubscriptions',
	'audited' => true,
	'activity_enabled' => false,
	'duplicate_merge' => true,
	'fields' => array(
		'filter_owner' =>
			array(
				'name' => 'filter_owner',
				'vname' => 'LBL_FILTER_OWNER',
				'type' => 'bool',
				'massupdate' => true,
				'default' => '0',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'disabled',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'dependency' => false,
				'readonly' => false,
			),
		'filter_favorite' =>
			array(
				'name' => 'filter_favorite',
				'vname' => 'LBL_FILTER_FAVORITE',
				'type' => 'bool',
				'massupdate' => true,
				'default' => '0',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'disabled',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'dependency' => false,
				'readonly' => false,
			),
		'filter_following' =>
			array(
				'name' => 'filter_following',
				'vname' => 'LBL_FILTER_FOLLOWING',
				'type' => 'bool',
				'massupdate' => true,
				'default' => '0',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'disabled',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'dependency' => false,
				'readonly' => false,
			),
		'filter_team' =>
			array(
				'name' => 'filter_team',
				'vname' => 'LBL_FILTER_TEAM',
				'type' => 'bool',
				'massupdate' => true,
				'default' => '0',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'disabled',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'dependency' => false,
				'readonly' => false,
			),
	),
	'relationships' => array(
	),
	'optimistic_locking' => true,
	'unified_search' => true,
	'duplicate_check' => array(
		'enabled' => true,
		'FilterDuplicateCheck' => array(
			'filter_template' => array(
				array('assigned_user_id' => array('$equals' => '$assigned_user_id')),
			),
			'ranking_fields' => array(
				array('in_field_name' => 'assigned_user_id', 'dupe_field_name' => 'assigned_user_id'),
			)
		)
	)
);

if (!class_exists('VardefManager')) {
	require_once 'include/SugarObjects/VardefManager.php';
}
VardefManager::createVardef('PX_GCMSubscriptions', 'PX_GCMSubscriptions', array('basic', 'assignable'));

$dictionary['PX_GCMSubscriptions']['fields']['name']['required'] = false;
$dictionary['PX_GCMSubscriptions']['fields']['assigned_user_name']['required'] = true;
$dictionary['PX_GCMSubscriptions']['fields']['assigned_user_name']['massupdate'] = false;
$dictionary['PX_GCMSubscriptions']['fields']['assigned_user_id']['duplicate_merge'] = 'enabled';
