<?php

/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/06_Customer_Center/10_Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */

$dictionary['PX_UserNews'] = array(
	'table' => 'px_usernews',
	'audited' => true,
	'activity_enabled' => false,
	'duplicate_merge' => true,
	'fields' => array(
		'message' =>
			array(
				'required' => false,
				'name' => 'message',
				'vname' => 'LBL_MESSAGE',
				'type' => 'text',
				'massupdate' => false,
				'default' => '',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'enabled',
				'duplicate_merge_dom_value' => '1',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'full_text_search' =>
					array(
						'boost' => '0',
						'enabled' => false,
					),
				'calculated' => false,
				'size' => '20',
				'studio' => 'visible',
				'rows' => '4',
				'cols' => '20',
			),
		'delivery_channel' =>
			array(
				'required' => false,
				'name' => 'delivery_channel',
				'vname' => 'LBL_DELIVERY_CHANNEL',
				'type' => 'enum',
				'massupdate' => true,
				'default' => '',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'enabled',
				'duplicate_merge_dom_value' => '1',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'len' => 100,
				'size' => '20',
				'options' => 'account_type_dom',
				'dependency' => false,
			),
		'message_type' =>
			array(
				'required' => false,
				'name' => 'message_type',
				'vname' => 'LBL_MESSAGE_TYPE',
				'type' => 'varchar',
				'massupdate' => false,
				'default' => '',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'enabled',
				'duplicate_merge_dom_value' => '1',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'size' => '20',
				'studio' => 'visible',
				'len' => 100,
			),
		'notified' =>
			array(
				'name' => 'notified',
				'vname' => 'LBL_NOTIFIED',
				'type' => 'bool',
				'massupdate' => true,
				'default' => '0',
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'enabled',
				'duplicate_merge_dom_value' => '1',
				'audited' => false,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'dependency' => false,
			),

		'px_newsfeed' =>
			array(
				'name' => 'px_newsfeed',
				'type' => 'link',
				'relationship' => 'px_newsfeed_px_usernews',
				'source' => 'non-db',
				'side' => 'right',
				'vname' => 'LBL_PX_NEWSFEED',
			),
		'px_newsfeed_id' =>
			array(
				'required' => false,
				'name' => 'px_newsfeed_id',
				'vname' => 'LBL_PX_NEWSFEED_ID',
				'type' => 'id',
				'massupdate' => 0,
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'disabled',
				'duplicate_merge_dom_value' => 0,
				'audited' => false,
				'reportable' => false,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'len' => 36,
				'size' => '20',
			),
		'px_newsfeed_name' =>
			array(
				'required' => true,
				'source' => 'non-db',
				'name' => 'px_newsfeed_name',
				'vname' => 'LBL_PX_NEWSFEED_NAME',
				'type' => 'relate',
				'massupdate' => 0,
				'no_default' => false,
				'comments' => '',
				'help' => '',
				'importable' => 'true',
				'duplicate_merge' => 'disabled',
				'duplicate_merge_dom_value' => '0',
				'audited' => true,
				'reportable' => true,
				'unified_search' => false,
				'merge_filter' => 'disabled',
				'calculated' => false,
				'len' => '255',
				'size' => '20',
				'link' => 'px_newsfeed',
				'id_name' => 'px_newsfeed_id',
				'module' => 'PX_NewsFeed',
				'rname' => 'name',
				'quicksearch' => 'enabled',
				'studio' => 'visible',
				'readonly' => false,
			),
		'parent_type' =>
			array(
				'name' => 'parent_type',
				'vname' => 'LBL_PARENT_TYPE',
				'type' => 'varchar',
				'required' => false,
				'len' => 255,
				'studio' => array('wirelesslistview' => false),
				'comment' => 'The Sugar object to which the call is related'
			),
		'parent_id' =>
			array(
				'name' => 'parent_id',
				'vname' => 'LBL_LIST_RELATED_TO_ID',
				'type' => 'id',
				'reportable' => false,
				'comment' => 'The ID of the parent Sugar object identified by parent_type'
			),
	),
	'relationships' => array(
		'px_newsfeed_px_usernews' =>
			array(
				'lhs_module' => 'PX_NewsFeed',
				'lhs_table' => 'px_newsfeed',
				'lhs_key' => 'id',
				'rhs_module' => 'PX_UserNews',
				'rhs_table' => 'px_usernews',
				'rhs_key' => 'px_newsfeed_id',
				'relationship_type' => 'one-to-many',
			)
	),
	'optimistic_locking' => true,
	'unified_search' => true,
);

if (!class_exists('VardefManager')) {
	require_once 'include/SugarObjects/VardefManager.php';
}
VardefManager::createVardef('PX_UserNews', 'PX_UserNews', array('basic', 'team_security', 'assignable'));